<script setup lang="ts">
import { onMounted, ref } from 'vue'
import { useStockStore } from '@/stores/stock'
import type { Material } from '@/types/Material'
import { useRoute } from 'vue-router'
import { useTypeStore } from '@/stores/type'
import { useDateStore } from '@/stores/date'

const headers = [
    {
      title: 'Id',
      key: 'id'
    },
    {
      title: 'Name',
      key: 'name'
    },
    {
      title: 'Price',
      key: 'price'
    },
    {
      title: 'Unit',
      key: 'unit'
    },
    {
      title: 'Minimum',
      key: 'minimum'
    },
    {
      title: 'Type',
      key: 'types',
      value: (item: any | Material) => item.type?.name
    }
]

const route = useRoute()
const materialTypeStore = useTypeStore()
const stockStore = useStockStore()
const dateStore = useDateStore()
const search = ref('')
const nowName = ref('')

onMounted(async () => {
  await stockStore.getMaterials()
  await materialTypeStore.getTypes()
  const strUser = localStorage.getItem('user')
  try {
    if (strUser) {
      const parsedUser = JSON.parse(strUser)
      nowName.value = parsedUser.fullName
    }
  } catch (error) {
    console.error('Error parsing user data:', error)
  }
})
</script>
<template>
  <!-- <NavigationDrawer></NavigationDrawer> -->
  <v-toolbar flat color="#212121">
    <v-toolbar-title>Check Stock</v-toolbar-title>
    <v-spacer></v-spacer>

    <v-text-field
      v-model="search"
      prepend-inner-icon="mdi-magnify"
      density="compact"
      label="Search"
      single-line
      flat
      hide-details
      variant="solo-filled"
      style="width: 1px"
    ></v-text-field>

    <!-- Put Dialog -->
    <v-menu transition="slide-y-transition">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" icon>
          <v-icon>mdi-dots-vertical</v-icon>
        </v-btn>
      </template>
      <v-list>
        <v-list-item>
          <v-list-item-title>
            <v-btn
              block
              active-color="deep-orange-darken-4"
              link
              title="Stock"
              :class="{ active: route.name === 'stock' }"
              :to="{ path: '/Stock' }"
              rounded="0"
              elevation="0"
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-package-variant-closed</v-icon>
              Stock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="OrderStock"
              :class="{ active: route.name === 'orderstock' }"
              :to="{ path: '/OrderStock' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-truck-delivery</v-icon>
              OrderStock
            </v-btn>
          </v-list-item-title>
          <v-list-item-title>
            <v-btn
              active-color="deep-orange-darken-4"
              link
              title="HistoryStock"
              :class="{ active: route.name === 'history' }"
              :to="{ path: '/History' }"
              rounded="0"
              elevation="0"
              block
              style="display: flex; justify-content: flex-start; align-items: left;"
              >
              <v-icon size="25">mdi-history</v-icon>
              HistoryStock
            </v-btn>
          </v-list-item-title>
        </v-list-item>
      </v-list>
    </v-menu>
  </v-toolbar>
  <div>
    <v-data-table v-model:search="search" :headers="headers" :items="stockStore.materials">
      <template v-slot:top> </template>
    </v-data-table>
  </div>
  <v-row>
    <v-col></v-col>
    <v-col></v-col>
    <v-col></v-col>
    <!-- Dialog Check -->
    <v-dialog v-model="stockStore.CheckDialog" persistent width="700">
      <template v-slot:activator="{ props }">
        <v-btn v-bind="props" style="background-color: #c7a17a; color: white">
            CheckStock
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h4">CheckStock</span>
          <v-card-text class="text-h6">User: {{ nowName }}</v-card-text>
          <v-card-text class="text-h6">Date: {{ dateStore.currentDate() }}</v-card-text>
        </v-card-title>
        <v-card-text style="max-height: 400px; overflow-y: auto;">
          <v-row v-for="(item, index) in stockStore.initialCheck" :key="index">
            <v-col style="margin-left: 10px">{{ item.name }}</v-col>
            <v-col style="margin-left: 10px">{{ item.minimum }}</v-col>
            <v-text-field v-model="item.unit"></v-text-field>
          </v-row>
        </v-card-text>
        <v-card-actions>  
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" size="larger" @click="stockStore.closeDialog()">
            Close
          </v-btn>
          <v-btn color="primary" variant="text" size="larger" @click="stockStore.saveUnit()"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- Dialog Confirm -->
    <v-dialog v-model="stockStore.dialogConfirm" max-width="500px">
      <v-card>
        <v-card-title class="text-h5" style="text-align: center">Confirm?</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="stockStore.closeDialogCon()">Cancel</v-btn>
          <v-btn color="primary" variant="text" @click="stockStore.addUnit(stockStore.initialCheck)">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- Dialog Reject-->
    <v-dialog v-model="stockStore.dialogReject" max-width="500px">
      <v-card>
        <v-card-title class="text-h5" style="text-align: center">
          <v-icon icon="mdi-alert" density="compact" size="small"></v-icon>Material
          Invaid.</v-card-title
        >
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="stockStore.close()">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-col></v-col>
    <v-col></v-col>
    <v-col></v-col>
  </v-row>
</template>
